]> git.ipfire.org Git - ipfire-2.x.git/blame - make.sh
berkeley: Update to 5.3.28
[ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
06fc566a 20# Copyright (C) 2007-2020 IPFire Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
e8ee3199
AF
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
d12e3fcd 27# If you update the version don't forget to update backupiso and add it to core update
2f767b7b 28VERSION="2.25" # Version number
656abbc6 29CORE="145" # Core Level (Filename)
e8ee3199
AF
30SLOGAN="www.ipfire.org" # Software slogan
31CONFIG_ROOT=/var/ipfire # Configuration rootdir
32NICE=10 # Nice level
33MAX_RETRIES=1 # prefetch/check loop
305a7b38 34BUILD_IMAGES=1 # Flash and Xen Downloader
15679d9f 35KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
36e2e992
MT
36
37# Information from Git
38GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
39GIT_TAG="$(git tag | tail -1)" # Git Tag
40GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
628e8c3a 41
181e9805 42TOOLCHAINVER=20200324
03ad5f93 43
69a6ec55
MT
44###############################################################################
45#
46# Beautifying variables & presentation & input output interface
47#
48###############################################################################
49
f9783277
MT
50# Remember if the shell is interactive or not
51if [ -t 0 ] && [ -t 1 ]; then
52 INTERACTIVE=true
53else
54 INTERACTIVE=false
55fi
56
401a1edc
MT
57# Sets or adjusts pretty formatting variables
58resize_terminal() {
59 ## Screen Dimentions
60 # Find current screen size
61 COLUMNS=$(tput cols)
62
63 # When using remote connections, such as a serial port, stty size returns 0
64 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
65 COLUMNS=80
66 fi
69a6ec55 67
401a1edc
MT
68 # Measurements for positioning result messages
69 OPTIONS_WIDTH=20
70 TIME_WIDTH=12
71 STATUS_WIDTH=8
72 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
73 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
74
e9a57acd
MT
75 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
76 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
401a1edc 77}
69a6ec55 78
401a1edc
MT
79# Initially setup terminal
80resize_terminal
f9783277 81
401a1edc
MT
82# Call resize_terminal when terminal is being resized
83trap "resize_terminal" WINCH
69a6ec55
MT
84
85# Define color for messages
86BOLD="\\033[1;39m"
87DONE="\\033[1;32m"
88SKIP="\\033[1;34m"
89WARN="\\033[1;35m"
90FAIL="\\033[1;31m"
91NORMAL="\\033[0;39m"
92
bcb9dc13 93# New architecture variables
dc7d6b20 94HOST_ARCH="$(uname -m)"
94571564 95
69a6ec55
MT
96PWD=$(pwd)
97BASENAME=$(basename $0)
98
15679d9f
MT
99# Debian specific settings
100if [ ! -e /etc/debian_version ]; then
df5e82b3 101 FULLPATH=`which $0`
15679d9f 102else
df5e82b3
MT
103 if [ -x /usr/bin/realpath ]; then
104 FULLPATH=`/usr/bin/realpath $0`
105 else
106 echo "ERROR: Need to do apt-get install realpath"
107 exit 1
108 fi
15679d9f 109fi
df5e82b3 110
69a6ec55 111# This is the directory where make.sh is in
aecbe123 112export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
69a6ec55 113
ebaecf2c
AF
114LOGFILE=$BASEDIR/log/_build.preparation.log
115export LOGFILE
15679d9f 116DIR_CHK=$BASEDIR/cache/check
ebaecf2c 117mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 118
69a6ec55
MT
119system_processors() {
120 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
121}
122
123system_memory() {
124 local key val unit
125
126 while read -r key val unit; do
127 case "${key}" in
128 MemTotal:*)
129 # Convert to MB
130 echo "$(( ${val} / 1024 ))"
131 break
132 ;;
133 esac
134 done < /proc/meminfo
135}
136
137configure_build() {
138 local build_arch="${1}"
139
140 if [ "${build_arch}" = "default" ]; then
141 build_arch="$(configure_build_guess)"
142 fi
143
144 case "${build_arch}" in
145 x86_64)
146 BUILDTARGET="${build_arch}-unknown-linux-gnu"
147 CROSSTARGET="${build_arch}-cross-linux-gnu"
148 BUILD_PLATFORM="x86"
7520b95a 149 CFLAGS_ARCH="-m64 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic"
69a6ec55
MT
150 ;;
151
152 i586)
153 BUILDTARGET="${build_arch}-pc-linux-gnu"
154 CROSSTARGET="${build_arch}-cross-linux-gnu"
155 BUILD_PLATFORM="x86"
7520b95a 156 CFLAGS_ARCH="-march=i586 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic -fomit-frame-pointer"
69a6ec55
MT
157 ;;
158
159 aarch64)
160 BUILDTARGET="${build_arch}-unknown-linux-gnu"
161 CROSSTARGET="${build_arch}-cross-linux-gnu"
162 BUILD_PLATFORM="arm"
840f0b9f 163 CFLAGS_ARCH=""
69a6ec55
MT
164 ;;
165
166 armv7hl)
167 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
168 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
169 BUILD_PLATFORM="arm"
170 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
171 ;;
172
173 armv5tel)
174 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
175 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
176 BUILD_PLATFORM="arm"
177 CFLAGS_ARCH="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
82454983 178 RUSTFLAGS="-Ccodegen-units=1"
69a6ec55
MT
179 ;;
180
181 *)
182 exiterror "Cannot build for architure ${build_arch}"
183 ;;
184 esac
185
186 # Check if the QEMU helper is available if needed.
187 if qemu_is_required "${build_arch}"; then
188 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
189
190 if [ -n "${qemu_build_helper}" ]; then
191 QEMU_TARGET_HELPER="${qemu_build_helper}"
192 else
193 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
194 fi
195 fi
196
197 BUILD_ARCH="${build_arch}"
198 TOOLS_DIR="/tools_${BUILD_ARCH}"
199
200 # Enables hardening
54114eb0 201 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
69a6ec55
MT
202
203 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
204 CXXFLAGS="${CFLAGS}"
205
206 # Determine parallelism
eeee108f 207 # We assume that each process consumes about
297473d5 208 # 128MB of memory. Therefore we find out how
eeee108f 209 # many processes fit into memory.
297473d5 210 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
eeee108f
MT
211 local cpu_max=$(( ${SYSTEM_PROCESSORS} + 1 ))
212
213 local parallelism
214 if [ ${mem_max} -lt ${cpu_max} ]; then
215 parallelism=${mem_max}
216 else
217 parallelism=${cpu_max}
69a6ec55 218 fi
212f17c1 219
eeee108f
MT
220 # Use this as default PARALLELISM
221 DEFAULT_PARALLELISM="${parallelism}"
222
212f17c1
MT
223 # Compression parameters
224 # We use mode 8 for reasonable memory usage when decompressing
225 # but with overall good compression
226 XZ_OPT="-8"
227
228 # We try to use as many cores as possible
229 XZ_OPT="${XZ_OPT} -T0"
230
231 # We need to limit memory because XZ uses too much when running
232 # in parallel and it isn't very smart in limiting itself.
233 # We allow XZ to use up to 70% of all system memory.
deffc275 234 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
212f17c1
MT
235
236 # XZ memory cannot be larger than 2GB on 32 bit systems
237 case "${build_arch}" in
238 i*86|armv*)
239 if [ ${xz_memory} -gt 2048 ]; then
240 xz_memory=2048
241 fi
242 ;;
243 esac
244
245 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
69a6ec55
MT
246}
247
248configure_build_guess() {
249 case "${HOST_ARCH}" in
87487585
MT
250 x86_64)
251 echo "x86_64"
252 ;;
253 i?86)
69a6ec55
MT
254 echo "i586"
255 ;;
256
257 aarch64)
258 echo "aarch64"
259 ;;
260
261 armv7*|armv6*|armv5*)
262 echo "armv5tel"
263 ;;
264
265 *)
266 exiterror "Cannot guess build architecture"
267 ;;
268 esac
269}
270
f9783277
MT
271stdumount() {
272 umount $BASEDIR/build/sys 2>/dev/null;
273 umount $BASEDIR/build/dev/shm 2>/dev/null;
274 umount $BASEDIR/build/dev/pts 2>/dev/null;
275 umount $BASEDIR/build/dev 2>/dev/null;
276 umount $BASEDIR/build/proc 2>/dev/null;
277 umount $BASEDIR/build/install/mnt 2>/dev/null;
278 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
279 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
280 umount $BASEDIR/build/usr/src/config 2>/dev/null;
281 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
282 umount $BASEDIR/build/usr/src/html 2>/dev/null;
283 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
284 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
ebaecf2c 285 umount $BASEDIR/build/usr/src/log 2>/dev/null;
f9783277 286 umount $BASEDIR/build/usr/src/src 2>/dev/null;
7c984de6 287 umount $BASEDIR/build/usr/src 2>/dev/null;
cb658c8c 288 umount $BASEDIR/build/tmp 2>/dev/null;
f9783277
MT
289}
290
291now() {
292 date -u "+%s"
69a6ec55
MT
293}
294
f9783277
MT
295format_runtime() {
296 local seconds=${1}
297
298 if [ ${seconds} -ge 3600 ]; then
299 printf "%d:%02d:%02d\n" \
300 "$(( seconds / 3600 ))" \
301 "$(( seconds % 3600 / 60 ))" \
302 "$(( seconds % 3600 % 60 ))"
303 elif [ ${seconds} -ge 60 ]; then
304 printf "%d:%02d\n" \
305 "$(( seconds / 60 ))" \
306 "$(( seconds % 60 ))"
69a6ec55 307 else
f9783277 308 printf "%d\n" "${seconds}"
69a6ec55 309 fi
f9783277 310}
69a6ec55 311
f9783277
MT
312print_line() {
313 local line="$@"
69a6ec55 314
f9783277 315 printf "%-${LINE_WIDTH}s" "${line}"
69a6ec55
MT
316}
317
f9783277
MT
318_print_line() {
319 local status="${1}"
320 shift
69a6ec55 321
f9783277
MT
322 if ${INTERACTIVE}; then
323 printf "${!status}"
324 fi
69a6ec55 325
f9783277
MT
326 print_line "$@"
327
328 if ${INTERACTIVE}; then
329 printf "${NORMAL}"
330 fi
331}
332
333print_headline() {
334 _print_line BOLD "$@"
69a6ec55
MT
335}
336
f9783277
MT
337print_error() {
338 _print_line FAIL "$@"
339}
340
341print_package() {
342 local name="${1}"
343 shift
69a6ec55 344
f9783277
MT
345 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
346 local options="$@"
347
348 local string="${name}"
349 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
350 string="${string} (${version})"
351 fi
352
353 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
fa8c758e 354 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
f9783277
MT
355}
356
357print_runtime() {
358 local runtime=$(format_runtime $@)
359
360 if ${INTERACTIVE}; then
361 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
362 else
363 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
69a6ec55 364 fi
f9783277
MT
365}
366
367print_status() {
368 local status="${1}"
369
370 local color="${!status}"
371
372 if ${INTERACTIVE}; then
373 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
374 else
375 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
69a6ec55 376 fi
f9783277 377}
69a6ec55 378
f9783277
MT
379print_build_stage() {
380 print_headline "$@"
381
382 # end line
383 printf "\n"
69a6ec55
MT
384}
385
f9783277
MT
386print_build_summary() {
387 local runtime=$(format_runtime $@)
388
389 print_line "*** Build finished in ${runtime}"
390 print_status DONE
69a6ec55
MT
391}
392
393exiterror() {
394 stdumount
395 for i in `seq 0 7`; do
396 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
397 losetup -d /dev/loop${i} 2>/dev/null
398 fi;
399 done
400
f9783277 401 # Dump logfile
66028310 402 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
69a6ec55
MT
403 echo # empty line
404
405 local line
406 while read -r line; do
407 echo " ${line}"
408 done <<< "$(tail -n30 ${LOGFILE})"
409 fi
410
f9783277
MT
411 echo # empty line
412
413 local line
414 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
415 print_error "${line}"
416 print_status FAIL
417 done
418
69a6ec55
MT
419 exit 1
420}
421
aecbe123
MT
422prepareenv() {
423 # Are we running the right shell?
54328605 424 if [ -z "${BASH}" ]; then
aecbe123
MT
425 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
426 fi
427
428 if [ -z "${BASH_VERSION}" ]; then
429 exiterror "Not running BASH shell."
430 fi
431
432 # Trap on emergency exit
433 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
434
435 # Resetting our nice level
658232a6 436 if ! renice ${NICE} $$ >/dev/null; then
658232a6 437 exiterror "Failed to set nice level to ${NICE}"
aecbe123
MT
438 fi
439
440 # Checking if running as root user
658232a6 441 if [ $(id -u) -ne 0 ]; then
df7f30a1 442 exiterror "root privileges required for building"
aecbe123
MT
443 fi
444
445 # Checking for necessary temporary space
f9783277 446 print_line "Checking for necessary space on disk $BASE_DEV"
aecbe123
MT
447 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
448 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
449 if (( 2048000 > $BASE_ASPACE )); then
450 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
451 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
f9783277 452 print_status FAIL
aecbe123
MT
453 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
454 fi
455 else
f9783277 456 print_status DONE
aecbe123
MT
457 fi
458
459 # Set umask
460 umask 022
461
462 # Set LFS Directory
463 LFS=$BASEDIR/build
464
aecbe123
MT
465 # Setup environment
466 set +h
467 LC_ALL=POSIX
82454983 468 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS
aecbe123
MT
469 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
470
471 # Make some extra directories
472 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
473 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
474 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
3608d485 475 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}} 2>/dev/null
7c984de6
MT
476
477 if [ "${ENABLE_RAMDISK}" = "on" ]; then
478 mkdir -p $BASEDIR/build/usr/src
92fbca34 479 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
ad853b56
MT
480
481 mkdir -p ${BASEDIR}/build/tmp
482 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 ${BASEDIR}/build/tmp
7c984de6
MT
483 fi
484
ebaecf2c 485 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
aecbe123
MT
486
487 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
488 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
489
490 # Make all sources and proc available under lfs build
491 mount --bind /dev $BASEDIR/build/dev
492 mount --bind /dev/pts $BASEDIR/build/dev/pts
493 mount --bind /dev/shm $BASEDIR/build/dev/shm
494 mount --bind /proc $BASEDIR/build/proc
495 mount --bind /sys $BASEDIR/build/sys
496 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
3608d485 497 mount --bind $BASEDIR/ccache/${BUILD_ARCH} $BASEDIR/build/usr/src/ccache
aecbe123
MT
498 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
499 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
500 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
501 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
502 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
ebaecf2c 503 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
aecbe123
MT
504 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
505
506 # Run LFS static binary creation scripts one by one
507 export CCACHE_DIR=$BASEDIR/ccache
36065e42 508 export CCACHE_TEMPDIR="/tmp"
aecbe123
MT
509 export CCACHE_COMPRESS=1
510 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
511
512 # Remove pre-install list of installed files in case user erase some files before rebuild
513 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
514
515 # Prepare string for /etc/system-release.
f48643e5
MT
516 local system_release="${NAME} ${VERSION} (${BUILD_ARCH})"
517
518 case "${GIT_BRANCH}" in
519 core*|beta?|rc?)
520 system_release="${system_release} - ${GIT_BRANCH}"
521 ;;
522 *)
9ff65bfa 523 system_release="${system_release} - core${CORE} Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
f48643e5 524 ;;
aecbe123 525 esac
4e54a8e2 526
f48643e5
MT
527 # Append -dirty tag for local changes
528 if [ "$(git status -s | wc -l)" != "0" ]; then
529 system_release="${system_release}-dirty"
530 fi
531
532 # Export variable
533 SYSTEM_RELEASE="${system_release}"
534
040160c7
MT
535 # Decide on PAKFIRE_TREE
536 case "${GIT_BRANCH}" in
537 core*)
538 PAKFIRE_TREE="stable"
539 ;;
540 master)
541 PAKFIRE_TREE="testing"
542 ;;
543 *)
544 PAKFIRE_TREE="unstable"
545 ;;
546 esac
547
4e54a8e2
MT
548 # Setup ccache cache size
549 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}" >/dev/null
aecbe123
MT
550}
551
69a6ec55
MT
552enterchroot() {
553 # Install QEMU helper, if needed
554 qemu_install_helper
555
556 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
557
558 PATH="${PATH}" chroot ${LFS} env -i \
559 HOME="/root" \
560 TERM="${TERM}" \
561 PS1="${PS1}" \
562 PATH="${PATH}" \
563 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
040160c7 564 PAKFIRE_TREE="${PAKFIRE_TREE}" \
69a6ec55
MT
565 NAME="${NAME}" \
566 SNAME="${SNAME}" \
567 VERSION="${VERSION}" \
568 CORE="${CORE}" \
569 SLOGAN="${SLOGAN}" \
570 TOOLS_DIR="${TOOLS_DIR}" \
571 CONFIG_ROOT="${CONFIG_ROOT}" \
572 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
573 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
82454983 574 RUSTFLAGS="${RUSTFLAGS}" \
69a6ec55
MT
575 BUILDTARGET="${BUILDTARGET}" \
576 CROSSTARGET="${CROSSTARGET}" \
577 BUILD_ARCH="${BUILD_ARCH}" \
578 BUILD_PLATFORM="${BUILD_PLATFORM}" \
579 CCACHE_DIR=/usr/src/ccache \
36065e42 580 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
69a6ec55
MT
581 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
582 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
486112ad 583 GOCACHE="/usr/src/ccache/go" \
69a6ec55 584 KVER="${KVER}" \
0d7a6f03 585 XZ_OPT="${XZ_OPT}" \
77c863a2 586 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
587 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
588 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
589 $(fake_environ) \
590 $(qemu_environ) \
591 "$@"
592}
593
594entershell() {
595 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
596 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
597 fi
598
599 echo "Entering to a shell inside LFS chroot, go out with exit"
ab8464f4 600 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
69a6ec55
MT
601
602 if enterchroot bash -i; then
603 stdumount
604 else
f9783277 605 print_status FAIL
69a6ec55
MT
606 exiterror "chroot error"
607 fi
608}
609
610lfsmakecommoncheck() {
611 # Script present?
612 if [ ! -f $BASEDIR/lfs/$1 ]; then
613 exiterror "No such file or directory: $BASEDIR/$1"
614 fi
615
f9783277
MT
616 # Print package name and version
617 print_package $@
69a6ec55
MT
618
619 # Check if this package is supported by our architecture.
620 # If no SUP_ARCH is found, we assume the package can be built for all.
621 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
622 # Check if package supports ${BUILD_ARCH} or all architectures.
623 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
405ee2b4 624 print_runtime 0
f9783277 625 print_status SKIP
69a6ec55
MT
626 return 1
627 fi
628 fi
629
630 # Script slipped?
631 local i
632 for i in $SKIP_PACKAGE_LIST
633 do
634 if [ "$i" == "$1" ]; then
f9783277 635 print_status SKIP
69a6ec55
MT
636 return 1;
637 fi
638 done
639
640 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
641
642 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
643 MESSAGE="$1\t " download >> $LOGFILE 2>&1
644 if [ $? -ne 0 ]; then
645 exiterror "Download error in $1"
646 fi
647
648 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
649 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
650 if [ $? -ne 0 ]; then
651 exiterror "md5sum error in $1, check file in cache or signature"
652 fi
653
654 return 0 # pass all!
655}
656
657lfsmake1() {
658 lfsmakecommoncheck $*
659 [ $? == 1 ] && return 0
660
69a6ec55
MT
661 cd $BASEDIR/lfs && env -i \
662 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
663 CCACHE_DIR="${CCACHE_DIR}" \
36065e42 664 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
69a6ec55
MT
665 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
666 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
667 CFLAGS="${CFLAGS}" \
668 CXXFLAGS="${CXXFLAGS}" \
77c863a2 669 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
670 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
671 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
672 make -f $* \
673 TOOLCHAIN=1 \
674 TOOLS_DIR="${TOOLS_DIR}" \
675 CROSSTARGET="${CROSSTARGET}" \
676 BUILDTARGET="${BUILDTARGET}" \
677 BUILD_ARCH="${BUILD_ARCH}" \
678 BUILD_PLATFORM="${BUILD_PLATFORM}" \
679 LFS_BASEDIR="${BASEDIR}" \
680 ROOT="${LFS}" \
681 KVER="${KVER}" \
f9783277 682 install >> $LOGFILE 2>&1 &
69a6ec55 683
f9783277
MT
684 if ! wait_until_finished $!; then
685 print_status FAIL
686 exiterror "Building $*"
69a6ec55
MT
687 fi
688
f9783277 689 print_status DONE
69a6ec55
MT
690}
691
692lfsmake2() {
693 lfsmakecommoncheck $*
694 [ $? == 1 ] && return 0
695
69a6ec55
MT
696 local PS1='\u:\w$ '
697
698 enterchroot \
ce9264a1 699 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
69a6ec55
MT
700 make -f $* \
701 LFS_BASEDIR=/usr/src install" \
f9783277 702 >> ${LOGFILE} 2>&1 &
69a6ec55 703
f9783277
MT
704 if ! wait_until_finished $!; then
705 print_status FAIL
706 exiterror "Building $*"
69a6ec55
MT
707 fi
708
f9783277 709 print_status DONE
69a6ec55
MT
710}
711
712ipfiredist() {
713 lfsmakecommoncheck $*
714 [ $? == 1 ] && return 0
715
69a6ec55
MT
716 local PS1='\u:\w$ '
717
718 enterchroot \
719 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
f9783277 720 >> ${LOGFILE} 2>&1 &
69a6ec55 721
f9783277
MT
722 if ! wait_until_finished $!; then
723 print_status FAIL
724 exiterror "Packaging $*"
725 fi
69a6ec55 726
f9783277
MT
727 print_status DONE
728}
729
730wait_until_finished() {
731 local pid=${1}
732
733 local start_time=$(now)
734
735 # Show progress
736 if ${INTERACTIVE}; then
737 # Wait a little just in case the process
738 # has finished very quickly.
739 sleep 0.1
740
741 local runtime
742 while kill -0 ${pid} 2>/dev/null; do
743 print_runtime $(( $(now) - ${start_time} ))
744
745 # Wait a little
746 sleep 1
747 done
69a6ec55 748 fi
f9783277
MT
749
750 # Returns the exit code of the child process
751 wait ${pid}
752 local ret=$?
753
754 if ! ${INTERACTIVE}; then
755 print_runtime $(( $(now) - ${start_time} ))
756 fi
757
758 return ${ret}
69a6ec55
MT
759}
760
761fake_environ() {
762 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
763
764 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
765
766 # Fake kernel version, because some of the packages do not compile
767 # with kernel 3.0 and later.
8634797e 768 env="${env} UTS_RELEASE=${KVER}-ipfire"
69a6ec55
MT
769
770 # Fake machine version.
771 env="${env} UTS_MACHINE=${BUILD_ARCH}"
772
773 echo "${env}"
774}
775
776qemu_environ() {
777 local env
778
779 # Don't add anything if qemu is not used.
780 if ! qemu_is_required; then
781 return
782 fi
783
784 # Set default qemu options
785 case "${BUILD_ARCH}" in
786 arm*)
787 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
788
789 env="${env} QEMU_CPU=${QEMU_CPU}"
790 ;;
791 esac
792
793 # Enable QEMU strace
794 #env="${env} QEMU_STRACE=1"
795
796 echo "${env}"
797}
798
799qemu_is_required() {
800 local build_arch="${1}"
801
802 if [ -z "${build_arch}" ]; then
803 build_arch="${BUILD_ARCH}"
804 fi
805
806 case "${HOST_ARCH},${build_arch}" in
807 x86_64,arm*|i?86,arm*|i?86,x86_64)
808 return 0
809 ;;
810 *)
811 return 1
812 ;;
813 esac
814}
815
816qemu_install_helper() {
817 # Do nothing, if qemu is not required
818 if ! qemu_is_required; then
819 return 0
820 fi
821
822 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
823 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
824 fi
825
826 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
827 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
828 fi
829
830
831 if [ -z "${QEMU_TARGET_HELPER}" ]; then
832 exiterror "QEMU_TARGET_HELPER not set"
833 fi
834
835 # Check if the helper is already installed.
836 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
837 return 0
838 fi
839
840 # Try to find a suitable binary that we can install
841 # to the build environment.
842 local file
843 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
844 # file must exist and be executable.
845 [ -x "${file}" ] || continue
846
847 # Must be static.
848 file_is_static "${file}" || continue
849
850 local dirname="${LFS}$(dirname "${file}")"
851 mkdir -p "${dirname}"
852
853 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
854 return 0
855 done
856
857 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
858}
859
860qemu_find_build_helper_name() {
861 local build_arch="${1}"
862
863 local magic
864 case "${build_arch}" in
865 arm*)
866 magic="7f454c4601010100000000000000000002002800"
867 ;;
868 x86_64)
869 magic="7f454c4602010100000000000000000002003e00"
870 ;;
871 esac
872
873 [ -z "${magic}" ] && return 1
874
875 local file
876 for file in /proc/sys/fs/binfmt_misc/*; do
877 # skip write only register entry
878 [ $(basename "${file}") = "register" ] && continue
879 # Search for the file with the correct magic value.
880 grep -qE "^magic ${magic}$" "${file}" || continue
881
882 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
883
884 [ -n "${interpreter}" ] || continue
885 [ "${interpreter:0:1}" = "/" ] || continue
886 [ -x "${interpreter}" ] || continue
887
888 echo "${interpreter}"
889 return 0
890 done
891
892 return 1
893}
894
895file_is_static() {
896 local file="${1}"
897
898 file ${file} 2>/dev/null | grep -q "statically linked"
899}
900
901update_language_list() {
902 local path="${1}"
903
904 local lang
905 for lang in ${path}/*.po; do
906 lang="$(basename "${lang}")"
907 echo "${lang%*.po}"
908 done | sort -u > "${path}/LINGUAS"
909}
910
1fb7f56e
MT
911contributors() {
912 local commits name
913
914 git shortlog --summary --numbered | while read -r commits name; do
915 echo "${name}"
916 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
917}
918
919update_contributors() {
920 echo -n "Updating list of contributors"
921
922 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
923
924 # Edit contributors into credits.cgi
e2338aa7
MT
925 local tmp="$(mktemp)"
926
927 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
928 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
929
930 # Copy back modified content
931 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
932 unlink "${tmp}"
1fb7f56e
MT
933
934 print_status DONE
935 return 0
936}
937
15b005d8 938# Default settings
99597de7 939CCACHE_CACHE_SIZE="4G"
15b005d8
MT
940ENABLE_RAMDISK="auto"
941
a98ab1d7
MT
942# Load configuration file
943if [ -f .config ]; then
944 . .config
945fi
946
813659f2
MT
947# TARGET_ARCH is BUILD_ARCH now
948if [ -n "${TARGET_ARCH}" ]; then
949 BUILD_ARCH="${TARGET_ARCH}"
950 unset TARGET_ARCH
951fi
952
85560933
MT
953# Get some information about the host system
954SYSTEM_PROCESSORS="$(system_processors)"
955SYSTEM_MEMORY="$(system_memory)"
956
dc7d6b20
MT
957if [ -n "${BUILD_ARCH}" ]; then
958 configure_build "${BUILD_ARCH}"
949544f5 959else
dc7d6b20 960 configure_build "default"
949544f5
MT
961fi
962
15b005d8
MT
963# Automatically enable/disable ramdisk usage
964if [ "${ENABLE_RAMDISK}" = "auto" ]; then
965 # Enable only when the host system has 4GB of RAM or more
966 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
967 ENABLE_RAMDISK="on"
968 fi
969fi
970
df5e82b3 971buildtoolchain() {
69a6ec55
MT
972 local error=false
973 case "${BUILD_ARCH}:${HOST_ARCH}" in
974 # x86_64
975 x86_64:x86_64)
976 # This is working.
977 ;;
978
979 # x86
980 i586:i586|i586:i686|i586:x86_64)
981 # These are working.
982 ;;
983 i586:*)
984 error=true
985 ;;
986
987 # ARM
988 arvm7hl:armv7hl|armv7hl:armv7l)
989 # These are working.
990 ;;
991
992 armv5tel:armv5tel|armv5tel:armv5tejl|armv5tel:armv6l|armv5tel:armv7l|armv5tel:aarch64)
993 # These are working.
994 ;;
995 armv5tel:*)
996 error=true
997 ;;
998 esac
999
1000 ${error} && \
1001 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
1002
1003 local gcc=$(type -p gcc)
1004 if [ -z "${gcc}" ]; then
1005 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
1006 fi
1007
6bd3a131
MT
1008 # Check ${TOOLS_DIR} symlink
1009 if [ -h "${TOOLS_DIR}" ]; then
1010 rm -f "${TOOLS_DIR}"
1011 fi
1012
1013 if [ ! -e "${TOOLS_DIR}" ]; then
1014 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
1015 fi
1016
1017 if [ ! -h "${TOOLS_DIR}" ]; then
1018 exiterror "Could not create ${TOOLS_DIR} symbolic link"
1019 fi
1020
ebaecf2c 1021 LOGFILE="$BASEDIR/log/_build.toolchain.log"
69a6ec55
MT
1022 export LOGFILE
1023
1024 lfsmake1 stage1
1025 lfsmake1 ccache PASS=1
1026 lfsmake1 binutils PASS=1
1027 lfsmake1 gcc PASS=1
1028 lfsmake1 linux KCFG="-headers"
1029 lfsmake1 glibc
1030 lfsmake1 gcc PASS=L
1031 lfsmake1 binutils PASS=2
1032 lfsmake1 gcc PASS=2
54d54148 1033 lfsmake1 zlib
69a6ec55
MT
1034 lfsmake1 ccache PASS=2
1035 lfsmake1 tcl
1036 lfsmake1 expect
1037 lfsmake1 dejagnu
1038 lfsmake1 pkg-config
1039 lfsmake1 ncurses
1040 lfsmake1 bash
1041 lfsmake1 bzip2
1042 lfsmake1 automake
1043 lfsmake1 coreutils
1044 lfsmake1 diffutils
1045 lfsmake1 findutils
1046 lfsmake1 gawk
1047 lfsmake1 gettext
1048 lfsmake1 grep
1049 lfsmake1 gzip
1050 lfsmake1 m4
1051 lfsmake1 make
1052 lfsmake1 patch
1053 lfsmake1 perl
46bbc13b 1054 lfsmake1 python3
69a6ec55
MT
1055 lfsmake1 sed
1056 lfsmake1 tar
1057 lfsmake1 texinfo
1058 lfsmake1 xz
85439ac7 1059 lfsmake1 bison
11b5e5cb 1060 lfsmake1 flex
69a6ec55 1061 lfsmake1 fake-environ
7b93b62b 1062 lfsmake1 strip
69a6ec55 1063 lfsmake1 cleanup-toolchain
df5e82b3
MT
1064}
1065
1066buildbase() {
ebaecf2c 1067 LOGFILE="$BASEDIR/log/_build.base.log"
69a6ec55
MT
1068 export LOGFILE
1069 lfsmake2 stage2
1070 lfsmake2 linux KCFG="-headers"
1071 lfsmake2 man-pages
1072 lfsmake2 glibc
1073 lfsmake2 tzdata
1074 lfsmake2 cleanup-toolchain
1075 lfsmake2 zlib
1076 lfsmake2 binutils
1077 lfsmake2 gmp
1078 lfsmake2 gmp-compat
1079 lfsmake2 mpfr
1080 lfsmake2 libmpc
1081 lfsmake2 file
1082 lfsmake2 gcc
1083 lfsmake2 sed
1084 lfsmake2 autoconf
1085 lfsmake2 automake
1086 lfsmake2 berkeley
1087 lfsmake2 coreutils
1088 lfsmake2 iana-etc
1089 lfsmake2 m4
1090 lfsmake2 bison
69a6ec55
MT
1091 lfsmake2 ncurses
1092 lfsmake2 procps
1093 lfsmake2 libtool
1094 lfsmake2 perl
1095 lfsmake2 readline
1096 lfsmake2 readline-compat
1097 lfsmake2 bzip2
3ece7859 1098 lfsmake2 xz
69a6ec55
MT
1099 lfsmake2 pcre
1100 lfsmake2 pcre-compat
1101 lfsmake2 bash
1102 lfsmake2 diffutils
1103 lfsmake2 e2fsprogs
1104 lfsmake2 ed
1105 lfsmake2 findutils
1106 lfsmake2 flex
1107 lfsmake2 gawk
1108 lfsmake2 gettext
d2315d00 1109 lfsmake2 go
69a6ec55
MT
1110 lfsmake2 grep
1111 lfsmake2 groff
1112 lfsmake2 gperf
1113 lfsmake2 gzip
1114 lfsmake2 hostname
1115 lfsmake2 iproute2
1116 lfsmake2 jwhois
1117 lfsmake2 kbd
1118 lfsmake2 less
4720fa0d 1119 lfsmake2 pkg-config
69a6ec55
MT
1120 lfsmake2 make
1121 lfsmake2 man
69a6ec55
MT
1122 lfsmake2 net-tools
1123 lfsmake2 patch
1124 lfsmake2 psmisc
1125 lfsmake2 shadow
1126 lfsmake2 sysklogd
1127 lfsmake2 sysvinit
1128 lfsmake2 tar
1129 lfsmake2 texinfo
1130 lfsmake2 util-linux
69a6ec55 1131 lfsmake2 vim
df5e82b3
MT
1132}
1133
15679d9f 1134buildipfire() {
ebaecf2c 1135 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 1136 export LOGFILE
489145db
MT
1137 lfsmake2 configroot
1138 lfsmake2 initscripts
1139 lfsmake2 backup
c38f55fe
MT
1140 lfsmake2 openssl
1141 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG='-sse2'
1ece41ec 1142 lfsmake2 kmod
e1c6cd05 1143 lfsmake2 udev
3755e358 1144 lfsmake2 popt
d4767896 1145 lfsmake2 libedit
489145db
MT
1146 lfsmake2 libusb
1147 lfsmake2 libusb-compat
1148 lfsmake2 libpcap
1149 lfsmake2 ppp
1150 lfsmake2 pptp
1151 lfsmake2 unzip
1152 lfsmake2 which
1153 lfsmake2 linux-firmware
489145db 1154 lfsmake2 dvb-firmwares
37b86fa9 1155 lfsmake2 xr819-firmware
489145db
MT
1156 lfsmake2 zd1211-firmware
1157 lfsmake2 rpi-firmware
26796f3a 1158 lfsmake2 intel-microcode
0e54ca26 1159 lfsmake2 pcengines-apu-firmware
489145db 1160 lfsmake2 bc
2a0947f2 1161 lfsmake2 u-boot MKIMAGE=1
489145db
MT
1162 lfsmake2 cpio
1163 lfsmake2 mdadm
1164 lfsmake2 dracut
de18b4de 1165 lfsmake2 libaio
489145db
MT
1166 lfsmake2 lvm2
1167 lfsmake2 multipath-tools
1168 lfsmake2 freetype
489145db
MT
1169 lfsmake2 libmnl
1170 lfsmake2 libnfnetlink
1171 lfsmake2 libnetfilter_queue
1172 lfsmake2 libnetfilter_conntrack
1173 lfsmake2 libnetfilter_cthelper
1174 lfsmake2 libnetfilter_cttimeout
1175 lfsmake2 iptables
0245f3b6 1176 lfsmake2 screen
54ead8ef 1177 lfsmake2 elfutils
8e6fb99d 1178
dc7d6b20 1179 case "${BUILD_ARCH}" in
68a36e26 1180 x86_64|aarch64)
489145db 1181 lfsmake2 linux KCFG=""
b389d731
AF
1182# lfsmake2 backports KCFG=""
1183# lfsmake2 e1000e KCFG=""
1184# lfsmake2 igb KCFG=""
1185# lfsmake2 ixgbe KCFG=""
489145db
MT
1186 lfsmake2 xtables-addons KCFG=""
1187 lfsmake2 linux-initrd KCFG=""
fc155193 1188 ;;
3d02c091
MT
1189 i586)
1190 # x86-pae (Native and new XEN) kernel build
489145db 1191 lfsmake2 linux KCFG="-pae"
b389d731
AF
1192# lfsmake2 backports KCFG="-pae"
1193# lfsmake2 e1000e KCFG="-pae"
1194# lfsmake2 igb KCFG="-pae"
1195# lfsmake2 ixgbe KCFG="-pae"
489145db
MT
1196 lfsmake2 xtables-addons KCFG="-pae"
1197 lfsmake2 linux-initrd KCFG="-pae"
3d02c091
MT
1198
1199 # x86 kernel build
489145db 1200 lfsmake2 linux KCFG=""
b389d731
AF
1201# lfsmake2 backports KCFG=""
1202# lfsmake2 e1000e KCFG=""
1203# lfsmake2 igb KCFG=""
1204# lfsmake2 ixgbe KCFG=""
489145db
MT
1205 lfsmake2 xtables-addons KCFG=""
1206 lfsmake2 linux-initrd KCFG=""
3d02c091 1207 ;;
544f40d4 1208
3d02c091 1209 armv5tel)
3d02c091 1210 # arm multi platform (Panda, Wandboard ...) kernel build
489145db 1211 lfsmake2 linux KCFG="-multi"
0a21d63f
AF
1212# lfsmake2 backports KCFG="-multi"
1213# lfsmake2 e1000e KCFG="-multi"
1214# lfsmake2 igb KCFG="-multi"
1215# lfsmake2 ixgbe KCFG="-multi"
489145db
MT
1216 lfsmake2 xtables-addons KCFG="-multi"
1217 lfsmake2 linux-initrd KCFG="-multi"
3d02c091
MT
1218 ;;
1219 esac
489145db 1220 lfsmake2 xtables-addons USPACE="1"
489145db
MT
1221 lfsmake2 libgpg-error
1222 lfsmake2 libgcrypt
1223 lfsmake2 libassuan
1224 lfsmake2 nettle
1a7db134 1225 lfsmake2 json-c
f3e62301 1226 lfsmake2 libconfig
489145db
MT
1227 lfsmake2 libevent
1228 lfsmake2 libevent2
1229 lfsmake2 expat
c8e9a7a8
WA
1230 lfsmake2 apr
1231 lfsmake2 aprutil
489145db
MT
1232 lfsmake2 unbound
1233 lfsmake2 gnutls
1234 lfsmake2 bind
1235 lfsmake2 dhcp
1236 lfsmake2 dhcpcd
1237 lfsmake2 boost
1238 lfsmake2 linux-atm
1239 lfsmake2 gdbm
1240 lfsmake2 pam
1241 lfsmake2 curl
1242 lfsmake2 tcl
1243 lfsmake2 sqlite
1244 lfsmake2 libffi
1245 lfsmake2 python
1246 lfsmake2 python3
b3ce3510
MT
1247 lfsmake2 grub
1248 lfsmake2 efivar
1249 lfsmake2 efibootmgr
489145db
MT
1250 lfsmake2 ca-certificates
1251 lfsmake2 fireinfo
1252 lfsmake2 libnet
1253 lfsmake2 libnl
1254 lfsmake2 libnl-3
1255 lfsmake2 libidn
1256 lfsmake2 nasm
4f516b87
MF
1257 lfsmake2 libarchive
1258 lfsmake2 cmake
489145db
MT
1259 lfsmake2 libjpeg
1260 lfsmake2 libjpeg-compat
1261 lfsmake2 libexif
1262 lfsmake2 libpng
1263 lfsmake2 libtiff
1264 lfsmake2 libart
1265 lfsmake2 gd
489145db
MT
1266 lfsmake2 slang
1267 lfsmake2 newt
1268 lfsmake2 libsmooth
1269 lfsmake2 attr
1270 lfsmake2 acl
1271 lfsmake2 libcap
b051eb68 1272 lfsmake2 libcap-ng
489145db
MT
1273 lfsmake2 pciutils
1274 lfsmake2 usbutils
1275 lfsmake2 libxml2
1276 lfsmake2 libxslt
1277 lfsmake2 BerkeleyDB
489145db
MT
1278 lfsmake2 cyrus-sasl
1279 lfsmake2 openldap
1280 lfsmake2 apache2
489145db
MT
1281 lfsmake2 web-user-interface
1282 lfsmake2 flag-icons
1283 lfsmake2 jquery
6033b271 1284 lfsmake2 bootstrap
489145db
MT
1285 lfsmake2 arping
1286 lfsmake2 beep
1df47cc9 1287 lfsmake2 libssh
8a960584 1288 lfsmake2 cdrkit
489145db
MT
1289 lfsmake2 dosfstools
1290 lfsmake2 reiserfsprogs
1291 lfsmake2 xfsprogs
1292 lfsmake2 sysfsutils
1293 lfsmake2 fuse
1294 lfsmake2 ntfs-3g
1295 lfsmake2 ethtool
489145db
MT
1296 lfsmake2 fcron
1297 lfsmake2 perl-GD
1298 lfsmake2 GD-Graph
1299 lfsmake2 GD-TextUtil
1300 lfsmake2 perl-Device-SerialPort
1301 lfsmake2 perl-Device-Modem
1302 lfsmake2 perl-Apache-Htpasswd
1303 lfsmake2 gnupg
1304 lfsmake2 hdparm
1305 lfsmake2 sdparm
1306 lfsmake2 mtools
1307 lfsmake2 whatmask
1308 lfsmake2 conntrack-tools
1309 lfsmake2 libupnp
1310 lfsmake2 ipaddr
1311 lfsmake2 iputils
1312 lfsmake2 l7-protocols
489145db
MT
1313 lfsmake2 hwdata
1314 lfsmake2 logrotate
1315 lfsmake2 logwatch
1316 lfsmake2 misc-progs
1317 lfsmake2 nano
1318 lfsmake2 URI
294aa009
AF
1319 lfsmake2 perl-CGI
1320 lfsmake2 perl-Switch
489145db
MT
1321 lfsmake2 HTML-Tagset
1322 lfsmake2 HTML-Parser
1323 lfsmake2 HTML-Template
1324 lfsmake2 Compress-Zlib
1325 lfsmake2 Digest
1326 lfsmake2 Digest-SHA1
1327 lfsmake2 Digest-HMAC
1328 lfsmake2 libwww-perl
1329 lfsmake2 Net-DNS
1330 lfsmake2 Net-IPv4Addr
1331 lfsmake2 Net_SSLeay
1332 lfsmake2 IO-Stringy
1333 lfsmake2 IO-Socket-SSL
1334 lfsmake2 Unix-Syslog
1335 lfsmake2 Mail-Tools
1336 lfsmake2 MIME-Tools
1337 lfsmake2 Net-Server
1338 lfsmake2 Convert-TNEF
1339 lfsmake2 Convert-UUlib
1340 lfsmake2 Archive-Tar
1341 lfsmake2 Archive-Zip
1342 lfsmake2 Text-Tabs+Wrap
1343 lfsmake2 Locale-Country
1344 lfsmake2 XML-Parser
1345 lfsmake2 Crypt-PasswdMD5
1346 lfsmake2 Net-Telnet
1347 lfsmake2 python-setuptools
1348 lfsmake2 python-clientform
1349 lfsmake2 python-mechanize
1350 lfsmake2 python-feedparser
1351 lfsmake2 python-rssdler
1352 lfsmake2 python-inotify
1353 lfsmake2 python-docutils
1354 lfsmake2 python-daemon
1355 lfsmake2 python-ipaddress
1356 lfsmake2 glib
f107bb39 1357 lfsmake2 GeoIP
eba8e481 1358 lfsmake2 geoip-database
489145db
MT
1359 lfsmake2 ntp
1360 lfsmake2 openssh
1361 lfsmake2 fontconfig
1362 lfsmake2 dejavu-fonts-ttf
70f6cba4 1363 lfsmake2 ubuntu-font-family
489145db
MT
1364 lfsmake2 freefont
1365 lfsmake2 pixman
1366 lfsmake2 cairo
1367 lfsmake2 pango
1368 lfsmake2 rrdtool
489145db
MT
1369 lfsmake2 setup
1370 lfsmake2 libdnet
59fe9735 1371 lfsmake2 rust
616395f3 1372 lfsmake2 jansson
91cc908f 1373 lfsmake2 yaml
3498300d 1374 lfsmake2 libhtp
1a5f0649 1375 lfsmake2 colm
2348cfff 1376 lfsmake2 ragel
52ebc66b 1377 lfsmake2 hyperscan
67752a95 1378 lfsmake2 suricata
489145db 1379 lfsmake2 oinkmaster
ef640882 1380 lfsmake2 ids-ruleset-sources
489145db
MT
1381 lfsmake2 squid
1382 lfsmake2 squidguard
1383 lfsmake2 calamaris
1384 lfsmake2 tcpdump
1385 lfsmake2 traceroute
1386 lfsmake2 vlan
1387 lfsmake2 wireless
1388 lfsmake2 pakfire
1389 lfsmake2 spandsp
adf3f4f4 1390 lfsmake2 lz4
489145db
MT
1391 lfsmake2 lzo
1392 lfsmake2 openvpn
489145db
MT
1393 lfsmake2 mpage
1394 lfsmake2 dbus
1395 lfsmake2 intltool
1396 lfsmake2 libdaemon
6064cd87 1397 lfsmake2 avahi
489145db 1398 lfsmake2 cups
489145db 1399 lfsmake2 lcms2
56170c2a 1400 lfsmake2 ghostscript
489145db
MT
1401 lfsmake2 qpdf
1402 lfsmake2 poppler
1403 lfsmake2 cups-filters
1404 lfsmake2 epson-inkjet-printer-escpr
1405 lfsmake2 foomatic
1406 lfsmake2 hplip
1407 lfsmake2 cifs-utils
1408 lfsmake2 krb5
1409 lfsmake2 samba
1410 lfsmake2 sudo
1411 lfsmake2 mc
1412 lfsmake2 wget
1413 lfsmake2 bridge-utils
489145db
MT
1414 lfsmake2 smartmontools
1415 lfsmake2 htop
1416 lfsmake2 chkconfig
1417 lfsmake2 postfix
1418 lfsmake2 fetchmail
489145db 1419 lfsmake2 clamav
294aa009 1420 lfsmake2 perl-NetAddr-IP
489145db 1421 lfsmake2 spamassassin
438edc64 1422 lfsmake2 perl-Net-LibIDN
489145db
MT
1423 lfsmake2 amavisd
1424 lfsmake2 dma
1425 lfsmake2 alsa
1426 lfsmake2 mpfire
1427 lfsmake2 guardian
1428 lfsmake2 libid3tag
1429 lfsmake2 libmad
1430 lfsmake2 libogg
1431 lfsmake2 libvorbis
1432 lfsmake2 libdvbpsi
1433 lfsmake2 flac
1434 lfsmake2 lame
1435 lfsmake2 sox
41f8d642 1436 lfsmake2 soxr
489145db
MT
1437 lfsmake2 libshout
1438 lfsmake2 xvid
1439 lfsmake2 libmpeg2
489145db
MT
1440 lfsmake2 gnump3d
1441 lfsmake2 rsync
489145db
MT
1442 lfsmake2 libtirpc
1443 lfsmake2 rpcbind
14fb55a5 1444 lfsmake2 keyutils
489145db
MT
1445 lfsmake2 nfs
1446 lfsmake2 gnu-netcat
1447 lfsmake2 ncat
1448 lfsmake2 nmap
489145db
MT
1449 lfsmake2 etherwake
1450 lfsmake2 bwm-ng
1451 lfsmake2 sysstat
489145db
MT
1452 lfsmake2 strongswan
1453 lfsmake2 rng-tools
1454 lfsmake2 lsof
1455 lfsmake2 br2684ctl
1456 lfsmake2 pcmciautils
1457 lfsmake2 lm_sensors
1458 lfsmake2 liboping
1459 lfsmake2 collectd
1460 lfsmake2 elinks
1461 lfsmake2 igmpproxy
1462 lfsmake2 fbset
1463 lfsmake2 opus
1464 lfsmake2 python-six
1465 lfsmake2 python-pyparsing
1466 lfsmake2 spice-protocol
1467 lfsmake2 spice
1468 lfsmake2 sdl
1469 lfsmake2 libusbredir
43c3a386 1470 lfsmake2 libseccomp
489145db
MT
1471 lfsmake2 qemu
1472 lfsmake2 sane
1473 lfsmake2 netpbm
489145db 1474 lfsmake2 netsnmpd
489145db 1475 lfsmake2 nagios_nrpe
2af354c2 1476 lfsmake2 nagios-plugins
489145db 1477 lfsmake2 icinga
01c2ea6b 1478 lfsmake2 observium-agent
489145db 1479 lfsmake2 ebtables
489145db 1480 lfsmake2 faad2
e91ceed6 1481 lfsmake2 alac
489145db
MT
1482 lfsmake2 ffmpeg
1483 lfsmake2 vdr
1484 lfsmake2 vdr_streamdev
489145db
MT
1485 lfsmake2 vdr_epgsearch
1486 lfsmake2 vdr_dvbapi
1487 lfsmake2 vdr_eepg
1488 lfsmake2 w_scan
489145db
MT
1489 lfsmake2 mpd
1490 lfsmake2 libmpdclient
1491 lfsmake2 mpc
985741db 1492 lfsmake2 perl-Net-CIDR-Lite
489145db
MT
1493 lfsmake2 perl-Net-SMTP-SSL
1494 lfsmake2 perl-MIME-Base64
1495 lfsmake2 perl-Authen-SASL
1496 lfsmake2 perl-MIME-Lite
1497 lfsmake2 perl-Email-Date-Format
1498 lfsmake2 git
1499 lfsmake2 squidclamav
1500 lfsmake2 vnstat
1501 lfsmake2 iw
1502 lfsmake2 wpa_supplicant
1503 lfsmake2 hostapd
1504 lfsmake2 pycurl
1505 lfsmake2 urlgrabber
1506 lfsmake2 syslinux
1507 lfsmake2 tftpd
1508 lfsmake2 cpufrequtils
489145db
MT
1509 lfsmake2 gutenprint
1510 lfsmake2 apcupsd
1511 lfsmake2 iperf
1512 lfsmake2 iperf3
1513 lfsmake2 7zip
1514 lfsmake2 lynis
489145db
MT
1515 lfsmake2 sshfs
1516 lfsmake2 taglib
489145db
MT
1517 lfsmake2 sslh
1518 lfsmake2 perl-gettext
1519 lfsmake2 perl-Sort-Naturally
1520 lfsmake2 vdradmin
489145db 1521 lfsmake2 perl-DBI
489145db
MT
1522 lfsmake2 perl-DBD-SQLite
1523 lfsmake2 perl-File-ReadBackwards
489145db 1524 lfsmake2 openvmtools
5d92a00e 1525 lfsmake2 libmicrohttpd
489145db
MT
1526 lfsmake2 motion
1527 lfsmake2 joe
1528 lfsmake2 monit
1529 lfsmake2 nut
1530 lfsmake2 watchdog
1531 lfsmake2 libpri
1532 lfsmake2 libsrtp
1533 lfsmake2 asterisk
489145db
MT
1534 lfsmake2 usb_modeswitch
1535 lfsmake2 usb_modeswitch_data
1536 lfsmake2 zerofree
489145db
MT
1537 lfsmake2 minicom
1538 lfsmake2 ddrescue
489145db
MT
1539 lfsmake2 miniupnpd
1540 lfsmake2 client175
1541 lfsmake2 powertop
1542 lfsmake2 parted
1543 lfsmake2 swig
2a0947f2 1544 lfsmake2 u-boot
6836e528 1545 lfsmake2 u-boot-friendlyarm
5c82a9f0 1546 lfsmake2 python-typing
489145db
MT
1547 lfsmake2 python-m2crypto
1548 lfsmake2 wireless-regdb
1549 lfsmake2 crda
1550 lfsmake2 libsolv
1551 lfsmake2 python-distutils-extra
1552 lfsmake2 python-lzma
1553 lfsmake2 python-progressbar
1554 lfsmake2 python-xattr
1555 lfsmake2 ddns
2d17377a 1556 lfsmake2 python3-setuptools
662b2a81 1557 lfsmake2 python3-setuptools-scm
9e25fe5c 1558 lfsmake2 python3-six
e0a05a80 1559 lfsmake2 python3-dateutil
d48ea6b5 1560 lfsmake2 python3-jmespath
a33ca4cc 1561 lfsmake2 python3-colorama
041d2116 1562 lfsmake2 python3-docutils
d2da17a1 1563 lfsmake2 python3-yaml
953f6f73 1564 lfsmake2 python3-s3transfer
d45d5247 1565 lfsmake2 python3-rsa
faa5472a 1566 lfsmake2 python3-pyasn1
4ab80c5d 1567 lfsmake2 python3-botocore
3be81987 1568 lfsmake2 python3-llfuse
def9f4a3 1569 lfsmake2 python3-msgpack
280ee7e7 1570 lfsmake2 aws-cli
489145db
MT
1571 lfsmake2 transmission
1572 lfsmake2 dpfhack
1573 lfsmake2 lcd4linux
1574 lfsmake2 mtr
489145db
MT
1575 lfsmake2 minidlna
1576 lfsmake2 acpid
1577 lfsmake2 fping
1578 lfsmake2 telnet
1579 lfsmake2 xinetd
1580 lfsmake2 gpgme
1581 lfsmake2 pygpgme
1582 lfsmake2 pakfire3
1583 lfsmake2 stress
1584 lfsmake2 libstatgrab
1585 lfsmake2 sarg
489145db
MT
1586 lfsmake2 nginx
1587 lfsmake2 sendEmail
1588 lfsmake2 sysbench
1589 lfsmake2 strace
489145db
MT
1590 lfsmake2 ltrace
1591 lfsmake2 ipfire-netboot
1592 lfsmake2 lcdproc
489145db
MT
1593 lfsmake2 keepalived
1594 lfsmake2 ipvsadm
1595 lfsmake2 perl-Carp-Clan
1596 lfsmake2 perl-Date-Calc
1597 lfsmake2 perl-Date-Manip
1598 lfsmake2 perl-File-Tail
1599 lfsmake2 perl-TimeDate
1600 lfsmake2 swatch
1601 lfsmake2 tor
489145db
MT
1602 lfsmake2 wavemon
1603 lfsmake2 iptraf-ng
1604 lfsmake2 iotop
1605 lfsmake2 stunnel
489145db 1606 lfsmake2 bacula
b62c826f
MT
1607 lfsmake2 perl-Font-TTF
1608 lfsmake2 perl-IO-String
489145db
MT
1609 lfsmake2 perl-PDF-API2
1610 lfsmake2 squid-accounting
1611 lfsmake2 pigz
1612 lfsmake2 tmux
1613 lfsmake2 perl-Text-CSV_XS
09b09b85 1614 lfsmake2 lua
489145db
MT
1615 lfsmake2 haproxy
1616 lfsmake2 ipset
489145db
MT
1617 lfsmake2 dnsdist
1618 lfsmake2 bird
1a7db134 1619 lfsmake2 frr
489145db
MT
1620 lfsmake2 dmidecode
1621 lfsmake2 mcelog
489145db
MT
1622 lfsmake2 util-macros
1623 lfsmake2 libpciaccess
1624 lfsmake2 libyajl
1625 lfsmake2 libvirt
1626 lfsmake2 freeradius
1627 lfsmake2 perl-common-sense
1628 lfsmake2 perl-inotify2
1629 lfsmake2 perl-Net-IP
0d6cc79d 1630 lfsmake2 wio
773caa66 1631 lfsmake2 iftop
ddcd60f7 1632 lfsmake2 mdns-repeater
429af178 1633 lfsmake2 i2c-tools
4e9000b4 1634 lfsmake2 nss-myhostname
014b235a 1635 lfsmake2 dehydrated
c708fa15 1636 lfsmake2 shairport-sync
46114d79 1637 lfsmake2 borgbackup
2397e513 1638 lfsmake2 knot
e1982c69 1639 lfsmake2 spectre-meltdown-checker
06fc6170 1640 lfsmake2 zabbix_agentd
82d176d3 1641 lfsmake2 flashrom
2aca6aa0 1642 lfsmake2 firmware-update
ffcef39d 1643 lfsmake2 tshark
392994dc 1644 lfsmake2 geoip-generator
9875e9f2 1645 lfsmake2 speedtest-cli
0db643ce 1646 lfsmake2 rfkill
44cc9a3d 1647 lfsmake2 amazon-ssm-agent
d0817963 1648}
df5e82b3
MT
1649
1650buildinstaller() {
1651 # Run installer scripts one by one
ebaecf2c 1652 LOGFILE="$BASEDIR/log/_build.installer.log"
df5e82b3 1653 export LOGFILE
489145db
MT
1654 lfsmake2 memtest
1655 lfsmake2 installer
ce9264a1
AF
1656 # use toolchain bash for chroot to strip
1657 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
df5e82b3
MT
1658}
1659
1660buildpackages() {
ebaecf2c 1661 LOGFILE="$BASEDIR/log/_build.packages.log"
df5e82b3
MT
1662 export LOGFILE
1663 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 1664
df5e82b3
MT
1665
1666 # Generating list of packages used
dc4ae0b7 1667 print_line "Generating packages list from logs"
df5e82b3 1668 rm -f $BASEDIR/doc/packages-list
ebaecf2c
AF
1669 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1670 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 1671 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
1672 fi
1673 done
7471f6ab 1674 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 1675 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
1676 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1677 rm -f $BASEDIR/doc/packages-list
c9673262 1678 # packages-list.txt is ready to be displayed for wiki page
f9783277 1679 print_status DONE
4b06f504
MT
1680
1681 # Update changelog
e49f7f0d 1682 cd $BASEDIR
c43b07fd
AF
1683 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1684 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1685 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
df5e82b3 1686
9607771a 1687 # Create images for install
489145db 1688 lfsmake2 cdrom
bada0832 1689
4dc82852 1690 # Check if there is a loop device for building in virtual environments
841663e7
MT
1691 modprobe loop 2>/dev/null
1692 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
489145db 1693 lfsmake2 flash-images
4dc82852 1694 fi
c9673262 1695
c4dd9dfc 1696 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
c9673262 1697
0d909a4a 1698 ipfirepackages
e67a57fe 1699
489145db 1700 lfsmake2 xen-image
939c2a21 1701 mv $LFS/install/images/*.bz2 $BASEDIR >> $LOGFILE 2>&1
bada0832 1702
b307417f 1703 cd $BASEDIR
744a04ea
AF
1704
1705 # remove not useable iso on armv5tel (needed to build flash images)
dc7d6b20 1706 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
744a04ea 1707
92244a40 1708 for i in `ls *.bz2 *.img.xz *.iso`; do
b307417f
AF
1709 md5sum $i > $i.md5
1710 done
1711 cd $PWD
1712
e67a57fe
MT
1713 # Cleanup
1714 stdumount
1715 rm -rf $BASEDIR/build/tmp/*
1716
e67a57fe 1717 cd $PWD
e67a57fe
MT
1718}
1719
1720ipfirepackages() {
489145db 1721 lfsmake2 core-updates
5596077b
MT
1722
1723 local i
dc7d6b20 1724 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
5596077b 1725 i=$(basename ${i})
453b418b
MT
1726 if [ -e $BASEDIR/lfs/$i ]; then
1727 ipfiredist $i
1728 else
1729 echo -n $i
f9783277 1730 print_status SKIP
453b418b 1731 fi
fe7fe395 1732 done
78331e30 1733 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 1734 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 1735 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
1736}
1737
bcb9dc13
MT
1738while [ $# -gt 0 ]; do
1739 case "${1}" in
1740 --target=*)
c2e810de 1741 configure_build "${1#--target=}"
bcb9dc13
MT
1742 ;;
1743 -*)
1744 exiterror "Unknown configuration option: ${1}"
1745 ;;
1746 *)
1747 # Found a command, so exit options parsing.
1748 break
1749 ;;
1750 esac
1751 shift
1752done
1753
df5e82b3
MT
1754# See what we're supposed to do
1755case "$1" in
1756build)
f9783277
MT
1757 START_TIME=$(now)
1758
1759 # Clear screen
1760 ${INTERACTIVE} && clear
1761
f74072a2 1762 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
df5e82b3 1763 #only restore on a clean disk
6c4cc7ea 1764 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
df5e82b3 1765 if [ ! -n "$PACKAGE" ]; then
f9783277 1766 print_build_stage "Full toolchain compilation"
df5e82b3
MT
1767 prepareenv
1768 buildtoolchain
1769 else
f74072a2 1770 PACKAGENAME=${PACKAGE%.tar.xz}
f9783277 1771 print_build_stage "Packaged toolchain compilation"
df5e82b3 1772 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
f74072a2 1773 tar axf $PACKAGE
df5e82b3
MT
1774 prepareenv
1775 else
1776 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1777 fi
1778 fi
1779 else
df5e82b3
MT
1780 prepareenv
1781 fi
5cfe86e6 1782
f9783277 1783 print_build_stage "Building LFS"
df5e82b3 1784 buildbase
15679d9f 1785
f9783277 1786 print_build_stage "Building IPFire"
15679d9f 1787 buildipfire
5cfe86e6 1788
f9783277 1789 print_build_stage "Building installer"
df5e82b3 1790 buildinstaller
15679d9f 1791
f9783277 1792 print_build_stage "Building packages"
df5e82b3 1793 buildpackages
7a5ed24e 1794
f9783277 1795 print_build_stage "Checking Logfiles for new Files"
b307417f
AF
1796
1797 cd $BASEDIR
7a5ed24e 1798 tools/checknewlog.pl
e0c923f4 1799 tools/checkrootfiles
b307417f 1800 cd $PWD
a23731d1 1801
f9783277 1802 print_build_summary $(( $(now) - ${START_TIME} ))
df5e82b3
MT
1803 ;;
1804shell)
1805 # enter a shell inside LFS chroot
1806 # may be used to changed kernel settings
1807 prepareenv
1808 entershell
1809 ;;
df5e82b3 1810clean)
f9783277
MT
1811 print_line "Cleaning build directory..."
1812
df5e82b3
MT
1813 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1814 $LOSETUP -d $i 2>/dev/null
1815 done
1816 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1817 umount $i
1818 done
1819 stdumount
1820 for i in `seq 0 7`; do
69a6ec55 1821 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
df5e82b3
MT
1822 umount /dev/loop${i} 2>/dev/null;
1823 losetup -d /dev/loop${i} 2>/dev/null;
69a6ec55 1824 fi;
df5e82b3
MT
1825 done
1826 rm -rf $BASEDIR/build
1827 rm -rf $BASEDIR/cdrom
f9315063 1828 rm -rf $BASEDIR/packages
ebaecf2c 1829 rm -rf $BASEDIR/log
6c4cc7ea
MT
1830 if [ -h "${TOOLS_DIR}" ]; then
1831 rm -f "${TOOLS_DIR}"
df5e82b3 1832 fi
b307417f 1833 rm -f $BASEDIR/ipfire-*
f9783277 1834 print_status DONE
df5e82b3 1835 ;;
4e432799
MT
1836docker)
1837 # Build the docker image if it does not exist, yet
1838 if ! docker images -a | grep -q ^ipfire-builder; then
1839 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1840 print_status DONE
1841 else
1842 print_status FAIL
1843 exit 1
1844 fi
1845 fi
1846
1847 # Run the container and enter a shell
1848 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1849 ;;
c3db995c 1850downloadsrc)
df5e82b3
MT
1851 if [ ! -d $BASEDIR/cache ]; then
1852 mkdir $BASEDIR/cache
1853 fi
ebaecf2c 1854 mkdir -p $BASEDIR/log
857d9bf2 1855 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
1856 FINISHED=0
1857 cd $BASEDIR/lfs
1858 for c in `seq $MAX_RETRIES`; do
1859 if (( FINISHED==1 )); then
1860 break
1861 fi
1862 FINISHED=1
1863 cd $BASEDIR/lfs
1864 for i in *; do
1865 if [ -f "$i" -a "$i" != "Config" ]; then
846e756e
MT
1866 lfsmakecommoncheck ${i} || continue
1867
dc7d6b20 1868 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1869 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
df5e82b3 1870 if [ $? -ne 0 ]; then
f9783277 1871 print_status FAIL
df5e82b3
MT
1872 FINISHED=0
1873 else
1874 if [ $c -eq 1 ]; then
f9783277 1875 print_status DONE
df5e82b3
MT
1876 fi
1877 fi
1878 fi
1879 done
1880 done
e22c7973 1881 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
1882 ERROR=0
1883 for i in *; do
1884 if [ -f "$i" -a "$i" != "Config" ]; then
a4130265 1885 lfsmakecommoncheck ${i} > /dev/null || continue
dc7d6b20 1886 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1887 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
df5e82b3 1888 if [ $? -ne 0 ]; then
e22c7973 1889 echo -ne "MD5 difference in lfs/$i"
f9783277 1890 print_status FAIL
df5e82b3
MT
1891 ERROR=1
1892 fi
1893 fi
1894 done
1895 if [ $ERROR -eq 0 ]; then
e22c7973 1896 echo -ne "${BOLD}all files md5sum match${NORMAL}"
f9783277 1897 print_status DONE
e22c7973
MT
1898 else
1899 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
f9783277 1900 print_status FAIL
df5e82b3 1901 fi
e22c7973 1902 cd - >/dev/null 2>&1
df5e82b3 1903 ;;
df5e82b3 1904toolchain)
f9783277
MT
1905 # Clear screen
1906 ${INTERACTIVE} && clear
1907
df5e82b3 1908 prepareenv
f3b7cf47 1909 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
df5e82b3 1910 buildtoolchain
f74072a2 1911 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
11104bfe 1912 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
ebaecf2c 1913 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log | xz ${XZ_OPT} \
b46f951e 1914 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz
f74072a2 1915 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
dc7d6b20 1916 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
df5e82b3
MT
1917 stdumount
1918 ;;
1919gettoolchain)
df5e82b3 1920 # arbitrary name to be updated in case of new toolchain package upload
dc7d6b20 1921 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
f74072a2 1922 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.xz ]; then
5bd13f01 1923 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
11104bfe 1924 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1925 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
712d859c 1926 cd $BASEDIR/cache/toolchains
f74072a2 1927 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.xz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c 1928 if [ $? -ne 0 ]; then
dc7d6b20 1929 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
40a4ea4c 1930 else
f74072a2 1931 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
712d859c
MT
1932 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1933 else
1934 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1935 fi
40a4ea4c 1936 fi
712d859c
MT
1937 else
1938 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
1939 fi
1940 ;;
15679d9f
MT
1941uploadsrc)
1942 PWD=`pwd`
661d9388
CS
1943 if [ -z $IPFIRE_USER ]; then
1944 echo -n "You have to setup IPFIRE_USER first. See .config for details."
f9783277 1945 print_status FAIL
661d9388
CS
1946 exit 1
1947 fi
ae23a606 1948
661d9388 1949 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
15e38431 1950 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
661d9388 1951
15e38431
MT
1952 for file in ${BASEDIR}/cache/*; do
1953 [ -d "${file}" ] && continue
1954 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
661d9388 1955 NEW_FILES="$NEW_FILES $file"
0eab8e84 1956 done
661d9388
CS
1957 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1958 cd $BASEDIR
15679d9f
MT
1959 cd $PWD
1960 exit 0
0eab8e84 1961 ;;
bf7c473f 1962lang)
69a6ec55
MT
1963 echo -ne "Checking the translations for missing or obsolete strings..."
1964 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1965 $BASEDIR/tools/sort_strings.pl en
1966 $BASEDIR/tools/sort_strings.pl de
1967 $BASEDIR/tools/sort_strings.pl fr
1968 $BASEDIR/tools/sort_strings.pl es
1969 $BASEDIR/tools/sort_strings.pl pl
1970 $BASEDIR/tools/sort_strings.pl ru
1971 $BASEDIR/tools/sort_strings.pl nl
1972 $BASEDIR/tools/sort_strings.pl tr
1973 $BASEDIR/tools/sort_strings.pl it
1974 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1975 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1976 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1977 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
1978 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.pl
1979 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1980 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1981 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1982 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1983 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
f9783277 1984 print_status DONE
69a6ec55
MT
1985
1986 echo -ne "Updating language lists..."
1987 update_language_list ${BASEDIR}/src/installer/po
1988 update_language_list ${BASEDIR}/src/setup/po
f9783277 1989 print_status DONE
bf7c473f 1990 ;;
1fb7f56e
MT
1991update-contributors)
1992 update_contributors
1993 ;;
6b8cff41 1994*)
1fb7f56e 1995 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors}"
6b8cff41
MT
1996 cat doc/make.sh-usage
1997 ;;
3ea75603 1998esac